# Copyright 2021- Le Filament (https://le-filament.com)
# License AGPL-3.0 or later (http://www.gnu.org/licenses/agpl.html)
from odoo import fields, models


class AccOperationWizardConfirm(models.TransientModel):
    _name = "acc.operation.wizard.confirm"
    _description = "Confirmation récupération des données vie API"

    # ------------------------------------------------------
    # Fields declaration
    # ------------------------------------------------------
    operation_id = fields.Many2one("acc.operation")
    start_date = fields.Date("Date de début")
    end_date = fields.Date("Date de fin (exclue)")
    prm_cons_ids = fields.Many2many(
        "acc.counter",
        relation="acc_counter_cons_confirm_rel",
        column1="cons_id",
        column2="op_id",
        string="PRM de soutirage",
    )
    prm_prod_ids = fields.Many2many(
        "acc.counter",
        relation="acc_counter_prod_confirm_rel",
        column1="prod_id",
        column2="op_id",
        string="PRM d'injection",
    )
    rec_ids = fields.Many2many("acc.enedis.cdc", string="Records")
    mess = fields.Text(
        string="Message",
    )
    # ------------------------------------------------------
    # SQL Constraints
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Default methods
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Computed fields / Search Fields
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Onchange / Constraints
    # ------------------------------------------------------

    # ------------------------------------------------------
    # CRUD methods (ORM overrides)
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Actions
    # ------------------------------------------------------
    def get_valid(self):
        # Suppression des enregistrements existants
        self.rec_ids.unlink()

        # Appels API
        # Si date présente, appel pour la période
        if self.start_date:
            self.env["acc.enedis.cdc"]._curves(
                self.operation_id,
                self.start_date,
                self.end_date,
                self.prm_cons_ids,
                self.prm_prod_ids,
            )
        else:
            # Pas de date renseignée, récupération de toutes les données
            self.env["acc.enedis.cdc"]._get_curves_all(
                self.operation_id, self.prm_cons_ids, self.prm_prod_ids
            )
        return {"type": "ir.actions.act_window_close"}

    # ------------------------------------------------------
    # Business methods
    # ------------------------------------------------------
